import { ErrorInfo, PureComponent, ReactNode } from 'react';
export interface PropsType {
    logToConsole?: boolean;
    errorMessage?: (error: unknown) => ReactNode;
    errorMessagePrefix?: ReactNode;
    variant?: string;
}
interface StateType {
    error: unknown;
    hasError: boolean;
}
export default class ErrorBoundary extends PureComponent<PropsType, StateType> {
    static defaultProps: {
        errorMessagePrefix: string;
        logToConsole: boolean;
        variant: string;
    };
    static getDerivedStateFromError(error: unknown): Partial<StateType>;
    private defaultErrorMessage;
    state: StateType;
    componentDidCatch(error: unknown, errorInfo: ErrorInfo): void;
    render(): ReactNode;
}
export {};
//# sourceMappingURL=ErrorBoundary.d.ts.map